Package com.xebialabs.xlrelease.domain.delivery

# Class Delivery

java.lang.Object
com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem
com.xebialabs.xlrelease.domain.delivery.Delivery

All Implemented Interfaces:
  `ConfigurationItem`, `CiWithInternalMetadata`, `TenantAwareCi`, `Serializable`, `Comparable<BaseConfigurationItem>`

@Metadata(root=BY_ROOT_NAME, rootName="Deliveries", versioned=false) public class Delivery extends BaseConfigurationItem implements CiWithInternalMetadata, TenantAwareCi

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `DELIVERY_ROOT`

  ### Fields inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

  `id, syntheticProperties, type`

  ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

  `SYNTHETIC_PROPERTIES_FIELD, TYPE_FIELD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Delivery()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addReleaseId(String releaseId)`
  `void`
  `addReleaseIds(Set<String> releaseIds)`
  `void`
  `addStage(Stage stage)`
  `void`
  `addStage(Stage stage, int position)`
  `void`
  `addSubscriber(Subscriber subscriber)`
  `void`
  `addTrackedItem(TrackedItem item)`
  `void`
  `computeReleasesFromTrackedItems()`
  `Optional<Stage>`
  `findFirstOpenStage()`
  `Optional<TrackedItem>`
  `findItemByIdOrTitle(String idOrTitle)`
  `Optional<Stage>`
  `findNextStage(Stage stage)`
  `Optional<Stage>`
  `findPreviousStage(Stage stage)`
  `Optional<Stage>`
  `findStageByIdOrTitle(String idOrTitle)`
  `Optional<Subscriber>`
  `findSubscriberBySourceId(String sourceId)`
  `Optional<Transition>`
  `findTransitionByIdOrTitle(String transitionIdOrTitle)`
  `Map<String,InternalMetadata>`
  `get$metadata()`
  `String`
  `getDescription()`
  `Date`
  `getEndDate()`
  `String`
  `getFolderId()`
  `TrackedItem`
  `getItemByIdOrTitle(String idOrTitle)`
  `String`
  `getOriginPatternId()`
  `Integer`
  `getPlannedDuration()`
  `Set<String>`
  `getReleaseIds()`
  `Stage`
  `getStageByIdOrTitle(String idOrTitle)`
  `Stage`
  `getStageByTransition(Transition transition)`
  `Stage`
  `getStageByTransitionId(String transitionId)`
  `List<Stage>`
  `getStageGroupAfterTransition(Transition transition)`
  `List<Stage>`
  `getStageGroupOfStage(Stage stage)`
  `List<Stage>`
  `getStages()`
  `List<Stage>`
  `getStagesBefore(Stage stage)`
  `List<Stage>`
  `getStagesBeforeFirstOpenTransition()`
  `Date`
  `getStartDate()`
  `DeliveryStatus`
  `getStatus()`
  `List<Subscriber>`
  `getSubscribers()`
  `<T extends Subscriber>
  List<T>`
  `getSubscribersOfType(Class<T> subscriberClass)`
  `String`
  `getTenantId()`
  `String`
  `getTitle()`
  `List<TrackedItem>`
  `getTrackedItems()`
  `Transition`
  `getTransitionByIdOrTitle(String transitionIdOrTitle)`
  `List<Transition>`
  `getTransitions()`
  `boolean`
  `isAutoComplete()`
  `boolean`
  `isLastStage(Stage stage)`
  `boolean`
  `isTemplate()`
  `boolean`
  `isUpdatable()`
  `void`
  `removeReleaseIds(List<String> idsToRemove)`
  `void`
  `removeStage(Stage stage)`
  `void`
  `removeTrackedItem(String itemId)`
  `void`
  `setAutoComplete(boolean autoComplete)`
  `void`
  `setDescription(String description)`
  `void`
  `setEndDate(Date endDate)`
  `void`
  `setFolderId(String folderId)`
  `void`
  `setOriginPatternId(String originPatternId)`
  `void`
  `setPlannedDuration(Integer plannedDuration)`
  `void`
  `setReleaseIds(Set<String> releaseIds)`
  `void`
  `setStages(List<Stage> stages)`
  `void`
  `setStartDate(Date startDate)`
  `void`
  `setStatus(DeliveryStatus status)`
  `void`
  `setSubscribers(List<Subscriber> subscribers)`
  `void`
  `setTenantId(String tenantId)`
  `void`
  `setTitle(String title)`
  `void`
  `setTrackedItems(List<TrackedItem> trackedItems)`
  `void`
  `updateDuration()`

  ### Methods inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

  `compareTo, equals, get$ciAttributes, get$directoryReference, get$externalProperties, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$token, get$validationMessages, getId, getName, getProperty, getPropertyDescriptor, getType, hashCode, hasProperty, set$ciAttributes, set$directoryReference, set$externalProperties, set$internalId, set$referenceId, set$securedCi, set$securedDirectoryReference, set$token, set$validationMessages, setId, setProperty, setType, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

  `get$directoryReference, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$validationMessages, getId, getName, getProperty, getType, hasProperty, setId, setProperty`

- ## Field Details

  - ### DELIVERY_ROOT

    public static final String DELIVERY_ROOT
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Delivery

    public Delivery()

- ## Method Details

  - ### isTemplate

    public boolean isTemplate()

  - ### updateDuration

    public void updateDuration()

  - ### findItemByIdOrTitle

    public Optional<TrackedItem> findItemByIdOrTitle(String idOrTitle)

  - ### getItemByIdOrTitle

    public TrackedItem getItemByIdOrTitle(String idOrTitle)

  - ### addStage

    public void addStage(Stage stage)

  - ### addStage

    public void addStage(Stage stage, int position)

  - ### removeStage

    public void removeStage(Stage stage)

  - ### isLastStage

    public boolean isLastStage(Stage stage)

  - ### findFirstOpenStage

    public Optional<Stage> findFirstOpenStage()

  - ### findPreviousStage

    public Optional<Stage> findPreviousStage(Stage stage)

  - ### findNextStage

    public Optional<Stage> findNextStage(Stage stage)

  - ### findStageByIdOrTitle

    public Optional<Stage> findStageByIdOrTitle(String idOrTitle)

  - ### getStageByIdOrTitle

    public Stage getStageByIdOrTitle(String idOrTitle)

  - ### getTransitions

    public List<Transition> getTransitions()

  - ### findTransitionByIdOrTitle

    public Optional<Transition> findTransitionByIdOrTitle(String transitionIdOrTitle)

  - ### getTransitionByIdOrTitle

    public Transition getTransitionByIdOrTitle(String transitionIdOrTitle)

  - ### getStageByTransition

    public Stage getStageByTransition(Transition transition)

  - ### getStageByTransitionId

    public Stage getStageByTransitionId(String transitionId)

  - ### getStagesBeforeFirstOpenTransition

    public List<Stage> getStagesBeforeFirstOpenTransition()

  - ### getStagesBefore

    public List<Stage> getStagesBefore(Stage stage)

  - ### getStageGroupAfterTransition

    public List<Stage> getStageGroupAfterTransition(Transition transition)

  - ### getStageGroupOfStage

    public List<Stage> getStageGroupOfStage(Stage stage)

  - ### getSubscribersOfType

    public <T extends Subscriber> List<T> getSubscribersOfType(Class<T> subscriberClass)

  - ### addSubscriber

    public void addSubscriber(Subscriber subscriber)

  - ### findSubscriberBySourceId

    public Optional<Subscriber> findSubscriberBySourceId(String sourceId)

  - ### getTitle

    public String getTitle()

  - ### setTitle

    public void setTitle(String title)

  - ### getDescription

    public String getDescription()

  - ### setDescription

    public void setDescription(String description)

  - ### getStatus

    public DeliveryStatus getStatus()

  - ### setStatus

    public void setStatus(DeliveryStatus status)

  - ### getStartDate

    public Date getStartDate()

  - ### setStartDate

    public void setStartDate(Date startDate)

  - ### getEndDate

    public Date getEndDate()

  - ### setEndDate

    public void setEndDate(Date endDate)

  - ### getReleaseIds

    public Set<String> getReleaseIds()

  - ### setReleaseIds

    public void setReleaseIds(Set<String> releaseIds)

  - ### removeReleaseIds

    public void removeReleaseIds(List<String> idsToRemove)

  - ### isUpdatable

    public boolean isUpdatable()

  - ### getFolderId

    public String getFolderId()

  - ### setFolderId

    public void setFolderId(String folderId)

  - ### getOriginPatternId

    public String getOriginPatternId()

  - ### setOriginPatternId

    public void setOriginPatternId(String originPatternId)

  - ### get$metadata

    public Map<String,InternalMetadata> get$metadata()
    Specified by:
      `get$metadata` in interface `CiWithInternalMetadata`

  - ### getTrackedItems

    public List<TrackedItem> getTrackedItems()

  - ### setTrackedItems

    public void setTrackedItems(List<TrackedItem> trackedItems)

  - ### getStages

    public List<Stage> getStages()

  - ### setStages

    public void setStages(List<Stage> stages)

  - ### addReleaseId

    public void addReleaseId(String releaseId)

  - ### addReleaseIds

    public void addReleaseIds(Set<String> releaseIds)

  - ### addTrackedItem

    public void addTrackedItem(TrackedItem item)

  - ### removeTrackedItem

    public void removeTrackedItem(String itemId)

  - ### getPlannedDuration

    public Integer getPlannedDuration()

  - ### setPlannedDuration

    public void setPlannedDuration(Integer plannedDuration)

  - ### getSubscribers

    public List<Subscriber> getSubscribers()

  - ### setSubscribers

    public void setSubscribers(List<Subscriber> subscribers)

  - ### computeReleasesFromTrackedItems

    public void computeReleasesFromTrackedItems()

  - ### isAutoComplete

    public boolean isAutoComplete()

  - ### setAutoComplete

    public void setAutoComplete(boolean autoComplete)

  - ### getTenantId

    public String getTenantId()
    Specified by:
      `getTenantId` in interface `TenantAwareCi`

  - ### setTenantId

    public void setTenantId(String tenantId)
    Specified by:
      `setTenantId` in interface `TenantAwareCi`